Getcsc_Hook:
	add a,e
	res GetcscHook,(iy+Hooks1)
	ld hl,Menu_About_Data
	ld de,progToEdit
	ld bc,8
	ldir
	ld hl,StartupCode_Checksum
	ld de,9872h
	ld bc,7
	ldir
	B_CALL CloseEditEqu
	B_CALL ExecuteApp
	xor a
	ret
StartupProtection:
	;Begin lockdown
	ld hl,StartupVectors
	B_CALL AppInit
	res battery,(iy+lockdown)
StartupProtection_NoNoNo:
	set 7,(iy+28h)
	B_CALL ClrScrnFull
	ld hl,50*256
	ld (pencol),hl
	ld hl,Startup_Message
	call vputstr
	ld de,57*256
	ld (pencol),de
	call vputstr
	ld hl,0
	ld (currow),hl
	B_CALL CursorOff
	B_CALL CursorOn
	bit battery,(iy+lockdown)
	jr z,StartupProtection_SkipPowerDown
	B_CALL EnableApd
	ld hl,0101h
	ld (apdSubTimer),hl
	res battery,(iy+lockdown)
StartupProtection_SkipPowerDown:
	res monabandon,(iy+monFlags)
	ld hl,enteredpass
	ld (hl),0
	ld de,enteredpass+1
	ld bc,7
	ldir
	ld ix,enteredpass
	xor a
	ld (enteredpasslen),a
StartupProtection_GetPasswordLoop:
	res onInterrupt,(iy+onFlags)
	B_CALL GetKey
	res apdRunning,(iy+apdFlags)
	cp kEnter
	jr nz,StartupProtection_NotEnter
	ld a,(enteredpasslen)
	or a
	jr z,StartupProtection_GetPasswordLoop
	jr StartupProtection_PasswordDone
StartupProtection_NotEnter:
	ld (ix),a
	inc ix
	ld a,'*'
	B_CALL PutC
	ld a,(enteredpasslen)
	inc a
	ld (enteredpasslen),a
	cp 8
	jr nz,StartupProtection_GetPasswordLoop
StartupProtection_PasswordDone:
	call LoadRealPassword
	ld hl,md5checksum
	ld de,md5checksum2
	ld bc,16
	ldir
	ld hl,enteredpass
	call MD5
	ld hl,md5checksum
	ld de,md5checksum2
	ld b,16
	call CompareStrings
	set battery,(iy+lockdown)
	jp nz,StartupProtection_NoNoNo
	;Password successful
	B_CALL ReloadAppEntryVecs
	B_CALL CursorOff
	res 7,(iy+28h)
	B_JUMP JForceCmdNoChar
Startup_Message:
	DB "A password is required",0
	DB "for operation.",0
StartupVectors:
	DW DummyReturn
	DW DummyReturn
	DW StopPutAway
	DW DummyReturn
	DW DummyReturn
	DW DummyReturn
	DB appTextSaveF
StopPutAway:
	set battery,(iy+lockdown)
	res plotLoc,(iy+plotFlags)
	res textWrite,(iy+sGrFlags)
	ld (iy+textFlags),0
	B_CALL SetTblGraphDraw
	bit monabandon,(iy+monFlags)
	jr nz,StopPutAway_TurningOff
	ld a,iall
	out (intrptEnPort),a
	B_CALL LCD_DRIVERON
	set onRunning,(iy+onFlags)
	ei
StopPutAway_TurningOff:
	B_CALL EnableApd
	ld hl,0101h
	ld (apdSubTimer),hl
	jp StartupProtection_NoNoNo
Hook:
	add a,e
	cp 36h		;check for memory menu
	jr z,Hook_Memory
	cp 2Ch		;check for APPS menu
	jr z,Hook_Apps
	cp 0ACh		;check for Alpha+S menu
	jr z,Hook_S
	cp kPrgm		;check for program menu
	jr z,Hook_Program
Hook_Safe_Exit:
	or a
	ret
Hook_Program:
	in a,(4)
	bit 3,a
	jr nz,Hook_Program_Exit
	;Find the appvar
	call Hook_FindAppVar
	inc de
	inc de
	ld a,(de)
	bit 3,a
	jr z,Hook_Program_Exit
	;Toggle programs between hidden and non-hidden
	xor 16
	ld (de),a
	and 00010000b
	srl a
	srl a
	srl a
	ld c,a
	;C is 0 if we are to hide, 1 to unhide
	;Search the VAT for programs!
	ld hl,(progPtr)
Hook_Program_VATnext:
	ld de,(pTemp)
	or a
	sbc hl,de
	jr z,Hook_Program_Exit
	jr c,Hook_Program_Exit
	add hl,de
	ld a,(hl)
	sub 6
	jr z,Hook_Program_Check
	inc a
	jr z,Hook_Program_Check
	ld de,-6
	add hl,de
	ld d,0
	ld e,(hl)
	inc e
	or a
	sbc hl,de
	jr Hook_Program_VATnext
Hook_Program_Check
	;We found a program
	ld de,-7
	add hl,de
	;HL is on the first byte of the name
	ld a,40h
	cp (hl)
	jr nc,Hook_Program_Hidden
	;The program is visible
	ld a,c
	or a
	jr nz,Hook_Program_No
	ld a,(hl)
	sub 40h
	ld (hl),a
	jr Hook_Program_No
Hook_Program_Hidden:
	ld a,c
	or a
	jr z,Hook_Program_No
	push hl
	ld de,PasswordFile+1
	ld b,8
	call ReverseCompare
	pop hl
	jr z,Hook_Program_No
	push hl
	ld de,PasswordFile+10
	ld b,8
	call ReverseCompare
	pop hl
	jr z,Hook_Program_No
	ld a,(hl)
	cp '!'
	jr z,Hook_Program_No
	cp '#'
	jr z,Hook_Program_No
	add a,40h
	ld (hl),a
Hook_Program_No:
	inc hl
	ld e,(hl)
	inc e
	ld d,0
	or a
	sbc hl,de
	jr Hook_Program_VATnext
Hook_Program_Exit:
	ld a,kPrgm
	or a
	ret
ReverseCompare:
	ld a,(de)
	cp (hl)
	ret nz
	dec hl
	inc de
	djnz ReverseCompare
	ret
Hook_S:
	ld a,(cxCurApp)
	cp cxMode
	jr nz,Hook_S_Exit
	push af
	call Hook_FindAppVar
	pop af
	jr c,Hook_Destroy
	inc de
	inc de
	ld a,(de)
	bit 1,a
	jr z,Hook_S_Exit
	call Hook_Secure
	jr z,Hook_S_Exit
	xor a
	ld (menucurrent),a
	B_JUMP JForceCmdNoChar
Hook_S_Exit:
	ld a,0ACh
	or a
	ret
Hook_Apps:
	push af
	call Hook_FindAppVar
	pop af
	jr c,Hook_Destroy
	inc de
	inc de
	ld a,(de)
	bit 0,a
	jr z,Hook_Apps_Exit
	call Hook_Secure
	jr z,Hook_Apps_Exit
	xor a
	ld (menucurrent),a
	B_JUMP JForceCmdNoChar
Hook_Apps_Exit:
	ld a,2Ch
	or a
	ret
Hook_Memory:
	push af
	call Hook_FindAppVar
	pop af
	jr c,Hook_Destroy
	inc de
	inc de
	ld a,(de)
	bit 1,a
	jr z,Hook_Memory_Exit
	;We need to protect this!
	call Hook_Secure
	jr z,Hook_Memory_Exit
	;It didn't match
	xor a
	ld (menucurrent),a
	B_JUMP JForceCmdNoChar
Hook_Memory_Exit:
	ld a,36h
	or a
	ret
Hook_Destroy:
	res GetKeyHook,(iy+Hooks1)
	or a
	ret
Hook_FindAppVar:
	ld hl,Password_AppVar
	rst 20h
	B_CALL ChkFindSym
	ret
Hook_Secure:
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,50*256
	ld (pencol),hl
	ld hl,Hook_Secure_Text
	call vputstr
	ld de,57*256
	ld (pencol),de
	call vputstr
	call GetPassword
	res 7,(iy+28h)
	call LoadRealPassword
	ld hl,md5checksum
	ld de,md5checksum2
	ld bc,16
	ldir
	ld hl,enteredpass
	call MD5
	ld hl,md5checksum
	ld de,md5checksum2
	ld b,16
	call CompareStrings
	res shift2nd,(iy+shiftflags)
	ret
Hook_Secure_Text:
	DB "This calculator requires",0
	DB "a password to continue.",0
